unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VCL.TMSFNCTypes, VCL.TMSFNCUtils, Vcl.StdCtrls,
  VCL.TMSFNCGraphics, VCL.TMSFNCGraphicsTypes, Vcl.ExtCtrls,
  VCL.TMSFNCBloxSelector, VCL.TMSFNCCustomControl,
  VCL.TMSFNCCustomScrollControl, VCL.TMSFNCBloxControl,
  VCL.TMSFNCBloxCoreBlock, VCL.TMSFNCBloxCorePath, VCL.TMSFNCBloxCoreElement,
  VCL.TMSFNCBloxCoreTypes,
  VCL.TMSFNCBloxUIRegistration;

type

  TANDBlock = class(TTMSFNCBloxBlock)
    protected
      procedure GetBlockPath(APath: TTMSFNCBloxPath; {%H-}ADrawer: TTMSFNCBloxBlockDrawer); override;
    public
      constructor Create; override;
  end;


  TNANDBlock = class(TTMSFNCBloxBlock)
    protected
      procedure GetBlockPath(APath: TTMSFNCBloxPath; {%H-}ADrawer: TTMSFNCBloxBlockDrawer); override;
    public
      constructor Create; override;
  end;


  TORBlock = class(TTMSFNCBloxBlock)
    protected
      procedure GetBlockPath(APath: TTMSFNCBloxPath; {%H-}ADrawer: TTMSFNCBloxBlockDrawer); override;
    public
      constructor Create; override;
  end;


  TfrmMain = class(TForm)
    TMSFNCBloxControl: TTMSFNCBloxControl;
    TMSFNCBloxSelector: TTMSFNCBloxSelector;
    Splitter: TSplitter;
    Panel: TPanel;
    procedure TMSFNCBloxControlRegisterElements(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}


//------------------------------------------------------------------------------
constructor TANDBlock.Create;
begin
  inherited Create;
  Restrictions := [crNoResize, crNoEdit, crNoRotation];
end;


//------------------------------------------------------------------------------
procedure TANDBlock.GetBlockPath(APath: TTMSFNCBloxPath; ADrawer: TTMSFNCBloxBlockDrawer);
var
  Poly: TTMSFNCBloxPointArray;

begin
  inherited;
  APath.Reset;

  APath.AddLine(50, 0, 0, 0);
  APath.AddLine(0, 0, 0, 100);
  APath.AddLine(0, 100, 50, 100);
  APath.AddBezier(50, 100, 90, 80, 90, 20, 50, 0);

  APath.AddEllipse(80, 40, 20, 20);



  //APath.AddArc(50, 100, 50, 100, 90, -180);

  {SetLength(Poly, 4);
  Poly[0].X := 50;
  Poly[0].Y := 100;
  Poly[1].X := 0;
  Poly[1].Y := 100;
  Poly[2].X := 0;
  Poly[2].Y := 0;
  Poly[3].X := 50;
  Poly[3].Y := 0;
  APath.AddPolygon(Poly);    }

end;


//------------------------------------------------------------------------------
constructor TNANDBlock.Create;
begin
  inherited Create;
  Restrictions := [crNoResize, crNoEdit, crNoRotation];
end;


//------------------------------------------------------------------------------
procedure TNANDBlock.GetBlockPath(APath: TTMSFNCBloxPath; ADrawer: TTMSFNCBloxBlockDrawer);
var
  Poly: TTMSFNCBloxPointArray;

begin
  inherited;
  APath.Reset;

  //APath.AddLine(

  //APath.AddBezier(0, 0, 25, 25, 25, 75, 0, 100);

  APath.AddArc(0, 0, 80, 100, -90, 180);

  SetLength(Poly, 4);
  Poly[0].X := 40;
  Poly[0].Y := 100;
  Poly[1].X := 0;
  Poly[1].Y := 100;
  Poly[2].X := 0;
  Poly[2].Y := 0;
  Poly[3].X := 40;
  Poly[3].Y := 0;
  APath.AddPolygon(Poly);

  APath.AddEllipse(80, 40, 20, 20);
end;


//------------------------------------------------------------------------------
constructor TORBlock.Create;
begin
  inherited Create;
  Restrictions := [crNoResize, crNoEdit, crNoRotation];
end;


//------------------------------------------------------------------------------
procedure TORBlock.GetBlockPath(APath: TTMSFNCBloxPath; ADrawer: TTMSFNCBloxBlockDrawer);
begin
  inherited;
  APath.Reset;
  APath.AddBezier(0, 0, 25, 25, 25, 75, 0, 100);
  APath.CloseFigure(False);
  APath.AddBezier(0, 100, 60, 95, 80, 80, 100, 50);
  APath.CloseFigure(False);
  APath.AddBezier(100, 50, 80, 20, 60, 5, 0, 0);
  APath.CloseFigure(False);


end;


//------------------------------------------------------------------------------
procedure TfrmMain.TMSFNCBloxControlRegisterElements(Sender: TObject);
begin
  //RegElementList.Clear;
  RegisterElement(TANDBlock, '', 'AND', 'Logic');
  RegisterElement(TNANDBlock, '', 'NAND', 'Logic');
  RegisterElement(TORBlock, '', 'OR', 'Logic');
end;


end.
